### Function

# FwupdPlugin ChunkArray new

since: 2.1.2

#### Declaration [src]

    GPtrArray*
    fu_chunk_array_new (
      const guint8* data,
      gsize data_sz,
      gsize addr_offset,
      gsize page_sz,
      gsize packet_sz,
      GError** error
    )

#### Description [src]

Chunks a linear blob of memory into packets, ensuring each packet does not cross a package boundary and is less that a specific transfer size.

Available since: 2.1.2

#### Parameters

`data`

  Type: `const guint8*`

  An optional linear blob of memory.

  The argument can be `NULL`.
  The data is owned by the caller of the function.

`data_sz`

  Type: `gsize`

  Size of `data_sz`.

`addr_offset`

  Type: `gsize`

  The hardware address offset, or 0.

`page_sz`

  Type: `gsize`

  The hardware page size, or 0.

`packet_sz`

  Type: `gsize`

  The transfer size, or 0.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: An array of `FuChunk*`

Array of packets, or `NULL`.

The caller of the function takes ownership of the data container, but not the data inside it.